#!/usr/bin/perl

# Author: Brandon Miller
# brandon[at]0daysclosure[dot]com
# d347h b4 d15c|05ur3

use strict;

# Generate random string for key and salt
my $str_gen;
sub str_gen{
  my $str_size = shift;
  my @chars = ('a'..'z', 'A'..'Z', 0..9);
  my $random_str = join '', map $chars[rand @chars], 0..$str_size;
  
  return $random_str;
}

 while(1){
  # Assign variables
  print "Plaintext Module Path: ";
  my $in_file = <STDIN>;
    
  print "Encrypted Module Path: ";
  chomp(my $out_file = <STDIN>);
  
 # Generate default encryption key
  my $generated_key = &str_gen(31);
  my $key;
  while(1){
    print "Encryption Key [$generated_key]: ";
    chomp($key = <STDIN>);
    
    if ($key == ''){
      $key = $generated_key;
      last;
    }elsif ((length($key) >= 32) && (length($key) <= 448)){
      last;
    }else{
      print "[!] Key must be between 8 bits and 448 bits in size...\n";
    }
  }
  
  # Generate default salt  
  my $generated_salt = &str_gen(7); 
  my $salt;
  while(1){
    print "Salt [$generated_salt]: ";
    chomp($salt = <STDIN>);
      
    if ($salt == ''){
      $salt = $generated_salt;
      last;
    }elsif(length($salt) == 8){
      last;
    }else{
      print "[!] Salt must be 8 bits in size...\n";
    }
  }
      
    
  # Create cipher
  use Crypt::CBC;
  my $cipher = Crypt::CBC->new(-key => $key,
	                    	-cipher => 'Blowfish',
				-salt => $salt
				);

  # Open text file for encryption
  open (INFILE, $in_file)
    or die "[!] Unable to open file...\n";
    
  # Assign text file content to variable
  my $content = do{local $/; <INFILE>;};
    
  # Close text file
  close INFILE;
    
  # Encrypt text file
  my $crypted = $cipher->encrypt($content);
  
  # Encode encrypted text into base 64
  use MIME::Base64;
  my $crypted64 = encode_base64($crypted);
    
  if(!(my $pid = fork)){
  # Open out file for writing
    open (OUTFILE, ">", $out_file)
      or die "[!] Could not open out file...\n";
      
    # Write encrypted text to file
    print OUTFILE $crypted64;
      
    # Close file
    close OUTFILE;
    
    print "[*] Text file encrypted successfully...\n";
    print "  Key: $key\n";
    print "  Salt: $salt\n\n";
    exit 1;
    }
    
  # Allow process time to fork to avoid interruption after loop
  sleep(1);
    
}
